unit hiLedRound;

interface

uses
  Windows,Kol,Share,Debug,Win;

type
  TStyle = (Raised, Lowered);
  TCheckMode = (mNone, mCheckBox, mRadioBtn);
  TPositionText = (tLeft,tRight,tCenter);

  THILedRound = class(THIWin)
  private
    FBmp,FAABitmap: PBitmap;
    FActive: Boolean;
    FActiveColor: TColor;
    FAutoInactiveColor: Boolean;
    FInactiveColor: TColor;
    FBackGroundColor: TColor;
    FLabel: PControl;
    procedure DrawBackGround;
    procedure Paint(Sender: PControl; DC: HDC);
    procedure _OnClick(Sender: PObj);
    procedure FastAntiAlias;
    procedure PaintStyle;
    procedure SetValue(Value: boolean);
  public
    _prop_Data: TData;
    _prop_ColorOn: TColor;
    _prop_ColorOff: TColor;
    _prop_Value: boolean;
    _prop_AutoOffColor: boolean;
    _prop_CheckMode: byte;
    _prop_Blick: boolean;
    _prop_PosText: byte;
    _prop_Caption: string;
    _prop_Style: byte;
    _event_onClick: THI_Event;
    _event_onChange: THI_Event;

    procedure Init;
    destructor Destroy; override;
    property BackGroundColor: TCOlor read FBackGroundColor write FBackGroundColor;

    procedure _work_doOn(var _Data: TData; Index: word);
    procedure _work_doOff(var _Data: TData; Index: word);
    procedure _work_doChangeValue(var _Data: TData; Index: word);
    procedure _work_doColorOn(var _Data: TData; Index: word);
    procedure _work_doColorOff(var _Data: TData; Index: word);
    procedure _work_doCaption(var _Data: TData; Index: word);
    procedure _work_doEnabled(var _Data: TData; Index: word);
    procedure _work_doVisible(var _Data: TData; Index: word);
    procedure _work_doValue(var _Data: TData; Index: word);
    procedure _var_Value(var _Data: TData; Index: word);

    //procedure _work_doSet(var _Data: TData; Index: word);

  end;

implementation

const
  MaxPixelCount = MaxInt div SizeOf(TRGBTriple);

type
  PRGBArray = ^TRGBArray;
  TRGBArray = array[0..MaxPixelCount-1] of TRGBTriple;



procedure THILedRound._work_doVisible;
begin
  Control.Visible := ReadBool(_Data);
  if Assigned(FLabel) then
    FLabel.Visible := Control.Visible;
end;

procedure THILedRound._work_doEnabled;
begin
  Control.Enabled := ReadBool(_Data);
  Control.Invalidate;
end;

procedure THILedRound._work_doCaption;
begin
  if Assigned(FLabel) then
    FLabel.Caption := ToString(_Data);
end;

procedure THILedRound.SetValue(Value: boolean);
var
  i: integer;
begin
  if TCheckMode(_prop_CheckMode) = mCheckBox then
  begin
    FActive := Value;
    Control.Invalidate;
    _hi_onEvent(_event_onChange, Integer(FActive));
  end;

  if TCheckMode(_prop_CheckMode) = mRadioBtn then
  begin
    for i := 0 to FParent.ChildCount-1 do
      if FParent.Children[i].SubClassName = 'THILedRound' then
      begin
        SetProp(FParent.Children[i].Handle,PChar('LOCK'),0);
        FParent.Children[i].Invalidate;
      end;
    SetProp(Control.Handle,PChar('LOCK'),1);
    FActive := True;
    Control.Invalidate;
    _hi_onEvent(_event_onChange, Integer(FActive));
  end;

  if TCheckMode(_prop_CheckMode) = mNone then
  begin
    Control.Invalidate;
    _hi_onEvent(_event_onChange, Integer(FActive));
  end;

end;

procedure THILedRound._work_doValue;
begin
  if TCheckMode(_prop_CheckMode) = mNone then
  begin
    FActive := ReadBool(_Data);
    Control.Invalidate;
    _hi_onEvent(_event_onChange,Integer(FActive));
    Exit;
  end;

  if TCheckMode(_prop_CheckMode) = mCheckBox then
  begin
    FActive := ReadBool(_Data);
    SetValue(FActive);
    Exit;
  end;
  //mRadioBtn
  if ReadBool(_Data) then SetValue(True);
end;

procedure THILedRound._OnClick(Sender: PObj);
begin
  if TCheckMode(_prop_CheckMode) <> mNone then
    SetValue(not FActive);

  _hi_onEvent(_event_onClick,_prop_Data);
end;

procedure THILedRound._work_doOn;
begin
  if TCheckMode(_prop_CheckMode) = mNone then
  begin
    FActive := True;
    Control.Invalidate;
    _hi_onEvent(_event_onChange,Integer(FActive));
  end else SetValue(True);

end;

procedure THILedRound._work_doOff;
begin
  if TCheckMode(_prop_CheckMode) = mRadioBtn then Exit;
  if TCheckMode(_prop_CheckMode) = mNone then
  begin
    FActive := False;
    Control.Invalidate;
    _hi_onEvent(_event_onChange,Integer(FActive));
  end else SetValue(False);
end;

procedure THILedRound._work_doChangeValue;
begin
  if TCheckMode(_prop_CheckMode) = mRadioBtn then Exit;
  if TCheckMode(_prop_CheckMode) = mNone then
  begin
    FActive := not FActive;
    Control.Invalidate;
    _hi_onEvent(_event_onChange,Integer(FActive));
  end else SetValue(not FActive);
end;

procedure THILedRound._work_doColorOn;
begin
  FActiveColor := ToInteger(_Data);
  Control.Invalidate;
end;

procedure THILedRound._work_doColorOff;
begin
  FInactiveColor := ToInteger(_Data);
  Control.Invalidate;
end;

procedure THILedRound._var_Value;
begin
  dtInteger(_Data, Integer(FActive));
end;

procedure THILedRound.Init;
begin
  Control := NewPaintBox(FParent);
  inherited;
  Control.SubClassName := 'THILedRound';
  //Control.Width := Control.Height;

  FBmp := NewBitmap(Control.Height*4,Control.Height*4);
  FBmp.PixelFormat := pf24bit;
  FAABitmap := NewBitmap(Control.Height, Control.Height);
  FAABitmap.PixelFormat := pf24bit;


  FActiveColor := _prop_ColorOn;
  FInactiveColor := _prop_ColorOff;
  FActive := _prop_Value;
  FBackGroundColor := FParent.Color;
  FAutoInactiveColor := _prop_AutoOffColor;
  if (TCheckMode(_prop_CheckMode) = mRadioBtn) then
    SetProp(Control.Handle,PChar('LOCK'),Integer(FActive));

  //if _prop_Caption <> '' then
  //begin
    if TPositionText(_prop_PosText) = tCenter then
      Flabel := Newlabel(FParent,_prop_Caption)
    else
      Flabel := Newlabel(Control,_prop_Caption);
    Flabel.Font.Assign(Control.Font);
    Flabel.AutoSize(True);
    Flabel.CursorLoad(0, MakeIntResource(_prop_Cursor));
    Flabel.Show;
    Flabel.OnClick := _OnClick;

    case TPositionText(_prop_PosText) of
     tRight:
      begin
        Flabel.Top := 0;
        Flabel.Height := Control.Height;
        Flabel.Left := Control.Height + 6;
        Flabel.VerticalAlign := vaCenter;
        //Flabel.TextAlign := taLeft;
      end;
     tLeft:
      begin
        Flabel.TextAlign := taRight;
        Flabel.VerticalAlign := vaCenter;
        Flabel.Top := 0;
        Flabel.Height := Control.Height;
        Flabel.Left := Control.Width - Control.Height - 6 - Flabel.Width;
      end;
     tCenter:
      begin
        Flabel.TextAlign := taCenter;
        Flabel.Top := Control.Top + Control.Height+2;
        Flabel.Left := (Control.Left + (Control.Width div 2))  - (Flabel.Width div 2);
      end;
    end;


  //end;

  Control.OnClick := _OnClick;
  Control.Onpaint := Paint;
  Control.Invalidate;
end;

destructor THILedRound.Destroy;
begin
  FBmp.Free;
  FAABitmap.Free;
  inherited;
end;

function DimColor(Value: TColor; Divisor: Integer): TColor;
var
  Red, Green, Blue: Integer;
begin
  if Divisor > 0 then
  begin
    Red := ((Value and $FF)) div Divisor;
    Green := ((Value and $FF00) shr 8) div Divisor;
    Blue := ((Value and $FF0000) shr 16) div Divisor;
  end
  else
  begin
    Red := (Value and $FF) * -Divisor;
    Green := ((Value and $FF00) shr 8) * -Divisor;
    Blue := ((Value and $FF0000) shr 16) * -Divisor;
  end;

  if Red > 255 then Red := 255;
  if Green > 255 then Green := 255;
  if Blue > 255 then Blue := 255;

  if Red < 0 then Red := 0;
  if Green < 0 then Green := 0;
  if Blue < 0 then Blue := 0;

  Result := Red + (Green shl 8) + (Blue shl 16);
end;

procedure THILedRound.Paint(Sender: PControl; DC: HDC);
begin
  if (TCheckMode(_prop_CheckMode) = mRadioBtn) then
    FActive := Boolean(GetProp(Control.Handle,PChar('LOCK')));

  PaintStyle;
  FastAntiAlias;
  DrawBackGround;

  case TPositionText(_prop_PosText) of
   tRight: FAABitmap.Draw(Control.Canvas.Handle, 0, 0);

   tLeft:  FAABitmap.Draw(Control.Canvas.Handle, Control.Width-Control.Height, 0);

   tCenter: FAABitmap.Draw(Control.Canvas.Handle, (Control.Width-Control.Height) div 2, 0);

  end;

end;

procedure THILedRound.DrawBackGround;
begin
  Control.Canvas.Brush.BrushStyle := bsSolid;
  Control.Canvas.Brush.Color := FParent.Color;
  Control.Canvas.FillRect(MakeRect(0, 0, Control.Width, Control.Height));
end;

procedure THILedRound.FastAntiAlias;
var
  x, y, cx, cy, cxi: Integer;
  totr, totg, totb: cardinal;
  Row1, Row2, Row3, Row4, DestRow: PRGBArray;
  i,k: Integer;
begin
  if not assigned(FBmp) then exit;
  cx:=0;
  K := 4; Row2 := nil; Row3 := nil; Row4 := nil;

  for Y := 0 to FAABitmap.Height - 1 do begin
    cy := y*K;
    Row1 := FBmp.ScanLine[cy];
    if Row1 = nil then exit;
    if K > 1 then Row2 := FBmp.ScanLine[cy+1];
    if K > 2 then Row3 := FBmp.ScanLine[cy+2];
    if K > 3 then Row4 := FBmp.ScanLine[cy+3];
    DestRow := FAABitmap.ScanLine[y];

    for x := 0 to FAABitmap.Width - 1 do begin
      cx := x*K;
      totr := 0; totg := 0; totb := 0;
      if K > 3 then begin
        for i := 0 to 3 do begin
          cxi := cx + i;
          totr := totr + Row1[cxi].rgbtRed + Row2[cxi].rgbtRed + Row3[cxi].rgbtRed + Row4[cxi].rgbtRed;
          totg := totg + Row1[cxi].rgbtGreen + Row2[cxi].rgbtGreen + Row3[cxi].rgbtGreen + Row4[cxi].rgbtGreen;
          totb := totb + Row1[cxi].rgbtBlue + Row2[cxi].rgbtBlue + Row3[cxi].rgbtBlue + Row4[cxi].rgbtBlue;
        end;
          DestRow[x].rgbtRed := totr shr 4;
          DestRow[x].rgbtGreen := totg shr 4;
          DestRow[x].rgbtBlue := totb shr 4;
      end;
    end;
  end;
  //FAntiAlias := True;
end;

function MyRGB(R, G, B: Integer): TColor;
begin
  if R < 0 then
    R := 0;
  if R > 255 then
    R := 255;
  if G < 0 then
    G := 0;
  if G > 255 then
    G := 255;
  if B < 0 then
    B := 0;
  if B > 255 then
    B := 255;
  Result := RGB(R, G, B);
end;

function BrightenColor(Color: TColor; Amount: Integer): TColor;
var
  BaseColor: LongInt;
begin
  BaseColor := Color2RGB(Color);
  Result := MyRGB(GetRValue(BaseColor) + Amount, GetGValue(BaseColor) + Amount, GetBValue(BaseColor) + Amount);
end;

function DarkenColor(Color: TColor; Amount: Integer): TColor;
begin
  Result := BrightenColor(Color, -Amount);
end;


procedure THILedRound.PaintStyle;
const
  ColorAmountBrighten = 42; //    72 def
  ColorAmountDarken = 42;
var
  R: TRect;
  i,nWidth,nHeight: integer;
begin
  R.Left := 0;
  R.Top := 0;
  R.Right := Control.Height*4;
  R.Bottom := Control.Height*4;
  with FBmp.Canvas {$ifndef F_P}^{$endif} do
  begin
    Brush.Color := FParent.Color;
    Brush.BrushStyle := bsSolid;
    FillRect(R);
    Brush.BrushStyle := bsClear;
    Pen.PenWidth := 2; //  

    i := 1;
    nWidth := (Control.Height*4);
    nHeight := (Control.Height*4);
    if TStyle(_prop_Style) = Lowered then
    begin
      Pen.Color := DarkenColor(FParent.Color, ColorAmountDarken);
      Arc(i, i, nWidth, nHeight, nWidth div 2 + nWidth div 4, i, i, nHeight div 2 + nHeight div 4);

      Pen.Color := DarkenColor(FParent.Color, ColorAmountDarken div 2);
      Arc(i, i, nWidth, nHeight, nWidth, i, nWidth div 2 + nWidth div 4, i);
      Arc(i, i, nWidth, nHeight, i, nHeight div 2 + nHeight div 4, i, nHeight);

      Pen.Color := BrightenColor(FParent.Color, ColorAmountBrighten);
      Arc(i, i, nWidth, nHeight, nWidth div 4, nHeight, nWidth, nHeight div 4);

      Pen.Color := BrightenColor(FParent.Color, ColorAmountBrighten div 4);
      Arc(i, i, nWidth, nHeight, nWidth, nHeight div 4, nWidth, i);
      Arc(i, i, nWidth, nHeight, i, nHeight, nWidth div 4, nHeight);

      Pen.Color := FParent.Color;
      Arc(i, i, nWidth, nHeight, i, nHeight - (nHeight div 12), nWidth div 12, nHeight);
      Arc(i, i, nWidth, nHeight, nWidth, nHeight div 12, nWidth - (nWidth div 12), i);
    end
    else
    begin
      Pen.Color := BrightenColor(FParent.Color, ColorAmountBrighten);
      Arc(i, i, nWidth, nHeight, nWidth div 2 + nWidth div 4, i, i, nHeight div 2 + nHeight div 4);

      Pen.Color := BrightenColor(FParent.Color, ColorAmountBrighten div 4);
      Arc(i, i, nWidth, nHeight, nWidth, i, nWidth div 2 + nWidth div 4, i);
      Arc(i, i, nWidth, nHeight, i, nHeight div 2 + nHeight div 4, i, nHeight);

      Pen.Color := DarkenColor(FParent.Color, ColorAmountDarken);
      Arc(i, i, nWidth, nHeight, nWidth div 4, nHeight, nWidth, nHeight div 4);

      Pen.Color := DarkenColor(FParent.Color, ColorAmountDarken div 2);
      Arc(i, i, nWidth, nHeight, nWidth, nHeight div 4, nWidth, i);
      Arc(i, i, nWidth, nHeight, i, nHeight, nWidth div 4, nHeight);

      Pen.Color := FParent.Color;
      Arc(i, i, nWidth, nHeight, i, nHeight - (nHeight div 12), nWidth div 12, nHeight);
      Arc(i, i, nWidth, nHeight, nWidth, nHeight div 12, nWidth - (nWidth div 12), i);
    end;

    if FActive then
      Brush.Color := FActiveColor
    else
      if FAutoInactiveColor then
        Brush.Color := DimColor(FActiveColor, 3)
    else
      Brush.Color := FInactiveColor;

    if not Control.Enabled then
    begin
      Brush.Color := clInactiveCaption;
      if Assigned(FLabel) then
        FLabel.Enabled := False;
    end else
    if Assigned(FLabel) then
      FLabel.Enabled := True;

    Brush.BrushStyle := bsSolid;
    Ellipse(i+3, i+3, nWidth-3,nHeight-3);

    if _prop_Blick then
    begin
      R := MakeRect(0, 0, FBmp.Width, FBmp.Height);
      Pen.Color := clWhite;
      Pen.PenWidth := 4;//!!!!!!!
      Arc(R.Left + FBmp.Width div 4, R.Top + FBmp.Width div 4, R.Right - FBmp.Width div 4, R.Bottom - FBmp.Width div 4, R.Right div 2, R.Top, R.Left, R.Bottom div 2);
      Arc(R.Left + FBmp.Width div 4 + 1, R.Top + FBmp.Width div 4 + 1, R.Right - FBmp.Width div 4 - 1, R.Bottom - FBmp.Width div 4 - 1, R.Right div 2, R.Top, R.Left, R.Bottom div 2);
    end;

  end;
end;

end.
